// Common fixes for IE6
(function($) {

	function fixpng() {
		// Code adapted from http://allinthehead.com/code/sleight/supersleight.plugin.js
		
		var self = $(this),
			bg = self.css('background-image');
		
		if ( bg && bg.match(/\.png/i) !== null ) {
			self.css({
				'filter': "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" +
					bg.substring(5,bg.length-2) + "', sizingMethod='" + 
					(self.css('background-repeat') == 'no-repeat' ? 'crop' : 'scale') + "')",
				'background-image': 'url(' +
					$('#confluence-context-path').attr('content') + '/images/border/spacer.gif' + ')'
			});
		}
	};

$(document)
	.bind('html', function(event) {
		var context = event.target;
		
		// Relay a label click to it's input element
		$('label:has(:input)', context)
			.bind('click', function(event) {
				if ( !$(event.target).is(':input') ) {
					$(':input', this).click();
				}
			});
		
		// Force a change event for checkboxes
		$(':checkbox', context)
			.bind('click', function() {
				var self = this;
				window.setTimeout(function() {
					$(self).trigger('change');
				}, 0);
			});
	
		window.setTimeout(function() {
			// Apply alpha transparency fix for PNG's
			$('.fixpng', context).each(fixpng);
		}, 0);
	});

})(jQuery);

