/*global jQuery, confirm */

(function($) {
	
	$('#layout-manager-panel-editor')
		
		.bind('atb-refresh.panel-editor', function(event) {
			var panelId = $(this).attr('data-ref');
			
			// Set the preview panel id so it gets updated
			$('#panel-display').attr('data-panel', panelId);
			
			// Force a panel update
			$(this).trigger('atb-panel-changed', [ panelId ]);
		})
		
		.bind('atb-fields-ready.panel-editor', function(event) {
			// Disable any tabs that don't have any active fields
			$(':role(tab)', this).each(function() {
				var tabpanel = $.roles.slaves(this),
					empty = !tabpanel.find('.atb-field').length;
				
				$(this)
					.attr('aria-disabled', empty)
					// TODO: tabs should respond to aria-disabled by changing the ui-state itself
					.toggleClass('ui-state-disabled', empty);
				
				tabpanel.toggleClass('ui-state-disabled', empty);
			});
		});
		
	$('.layout-preview')
	
		.bind('click.preview-edit', function(event) {
			var panelId = $(event.target).closest('[data-panel]').attr('data-panel');
			
			if ( panelId ) {
				var dialog = $('#layout-manager-panel-editor');
				
				if ( dialog.hasClass('dialog-modified') ) {
					// TODO: Extract confirm message from markup
					if ( confirm("You have unapplied panel changes, continue and lose the changes?") ) {
						dialog.trigger('dialog-undo');
					} else {
						return;
					}
				}

				dialog
					.attr('data-ref', panelId)
					.trigger('atb-activate');
			}
		});

	$('#layout-manager')
		
		.bind('atb-panel-changed.preview-edit', function(event, panelId) {
			var layoutData = $(this).data('atb-layout'),
				panelData = layoutData && layoutData[panelId],
				visible = panelData && panelData.visible;
			
			if ( visible === true || visible === false ) {
				var checkbox = $('#layout-manager-panel-toggles :checkbox[name='+panelId+']');
				checkbox[0].checked = visible;
				
				if ( /Sidebar$/.test(panelId) ) {
					panelId = panelId.replace('Sidebar','Slider');
					checkbox = $('#layout-manager-panel-toggles :checkbox[name='+panelId+']');

					// Disable slider checkbox if sidebar is hidden
					checkbox
						.attr('disabled', !visible)
						.toggleClass('force-disabled', !visible);

					// Force update of the slider panel
					$(this).trigger('atb-panel-changed', panelId);
				}
			}
		})
	
		.bind('atb-field-changed.preview-edit', function(event, field) {
			var data = field && field.getDataPair().obj;
			// Is this a panel field?
			if ( data && data.panelId ) {
				$(this).trigger('atb-panel-changed', [ data.panelId() ]);
			}
		});

})(jQuery);

