/*global jQuery, window */

(function($) {
	// TODO: merge this with css-properties.js

	function revert(input, origin) {
		input.trigger('atb-field-revert', origin);
	}

	var actions = {		
		parent: revert,
		overlay: revert,
		'default': function() {} // TODO
	};
	
	var popupTrigger;
	
	function popup(menu, input, opts) {
		var id = menu.attr('id');
		
		menu.appendTo('body')
			.removeClass('hidden')
			.position(opts)
			.bind('click.atb-popup-menu', function(event) {
				var a = $(event.target).closest('a'),
					value = a.attr('data-value'),
					action = a.attr('data-action') || (value === undefined || value === null ? 'none' : 'value');
				
				actions[action](input, action, value);
				
				// Prevent links from being followed
				event.preventDefault();
			});
		
		// Hide the menu when a click occurs anywhere in the document
		$(document).one('click.atb-popup-menu', function(event) {
				menu.addClass('hidden')
					.unbind('.atb-popup-menu');
				
				popupTrigger = undefined;
			});
	}

	$(document)
		.bind('html', function(event) {
			// Wire-up the popup activation buttons
			$('.revert-button', event.target)
				.unbind('click.revert-button')
				.bind('click.revert-button', function(event) {
					// Don't reshow the menu if already displayed from this button
					if ( this !== popupTrigger ) {
						var input = $(event.target).closest('[data-ref]').find('.layout-field'),
							menu = $.dt.attr(this, 'aria-controls', 'idrefs'),
							btn = this;
					
						// The timeout ensure that the current event queue is cleared.
						// This prevents the 'click to close' popup handler from being fired.
						window.setTimeout(function() {
							popup(menu, input, {
								my: 'left top',
								at: 'right top',
								of: btn,
								collision: 'none'
							});
							popupTrigger = btn;
						}, 0);
					}
					event.preventDefault();
				});
		})
		
		.bind('atb-init', function(event) {
			// Find all textarea panels in new dialogs
			$(event.target)
				.filter(':role(dialog)')
				.find('.ui-layout-editor:has(textarea.layout-field)')
				.each(function() {
					var textarea = $('textarea.layout-field', this),
						tab = $.roles.masters(this).filter(':role(tab)');
				
					if ( tab.length ) {
						// Create a dropdown trigger icon
						tab.addClass('atb-hasdropdown');
						$('<span class="atb-tab-dropdown ui-icon ui-icon-triangle-1-s"/>')
							.bind('click.tab-dropdown', function(event) {
								var disabled = $.dt.bool($(this).closest(':role(tab)').attr('aria-disabled')),
									btn = this;
								if ( !disabled && this !== popupTrigger ) {
									window.setTimeout(function() {
										popup($('#atb-popup-revert'), textarea, {
											my: 'center top',
											at: 'center bottom',
											of: btn,
											collision: 'none'
										});
										popupTrigger = btn;
									}, 0);
								}
								event.preventDefault();
							})
							.appendTo(tab);
					}
				});
		});
})(jQuery);

