/*jslint bitwise: true, eqeqeq: true, nomen: true, undef: true */
/*global jQuery, ThemeAdminDWR, document */

// requires: jquery, mvc, mvc-dwr, autocomplete

jQuery(function($) {

	var panel = $('#permissions-panel');
	
	function busy() { panel.busy(true); }
	function done() { panel.busy(false); }
	
	$.mvc.setter.acl = function(v) { $(this).val(v.join(', ')); };
	$.mvc.getter.acl = function() { return this.disabled ? undefined : $(this).val().split(/\s*,\s*/); };

	function setup() {
		$(panel).mvcInit();

		$.mvc('/ac/perms/*').bind(function() {
			// Commit the permissions
			busy();
			ThemeAdminDWR.setGlobalPermission(this.key(), this.val(), done);
		});
		
		panel.trigger('ready');
	}
	
	// Load global permissions and groups that may be assigned the permissions
	$.mvc('/ac/-')
		.key('perms').dwr(ThemeAdminDWR.getGlobalPermissions)
//		.key('roles').dwr(ThemeAdminDWR.getGroups)
		.dwrGo(setup);
});

