if (typeof(Visibility)=="undefined") var Visibility = (function () {
    // visibilty toggle & store
    var visibilitySetting={};
    function getVisibilityData(id) {
        var data = {method:null, states:"", visible:null};
        if (document.cookie!=null) {
            var s=document.cookie.indexOf("sitebuilder_visibility")
            if (s>-1) {
                s+=23;
                var e=document.cookie.indexOf(";",s)-s;
                if (e<1) e=document.cookie.length-s;
                if (e>-1) {
                    var states=data.states=document.cookie.substr(s,e);
                    if ((s=states.indexOf(":"+id+":"))>-1) {
                        data.states=states.substr(0,s)+states.substr(s+id.length+4);
                        data.method=states.substr(s+id.length+2,1);
                        data.visible=(states.substr(s+id.length+3,1)=="t")
                    }
                }
            }
        }
        return data;
    }
    function setVisibilityCookie (id, state, method) {
        if (document.cookie!=null) {
            var visData = getVisibilityData(id);
            method=(method!=null) ? method : "p";
            document.cookie = "sitebuilder_visibility="+visData.states+":"+id+":"+method+((state) ? "t" : "f")+"; path=/;";
        }
    }
    // Highlight Fade Appear Puff BlindUp BlindDown SwitchOff DropOut Shake SlideDown SlideUp Squish Grow Shrink Pulsate Fold
    var visibilityStyles = {fade:{show:"Appear",hide:"Fade"}};
    function addVisibilityStyle (style, show, hide) {
        if ((style==null) ||(show==null) ||(show==null)) return false;
        visibilityStyles[style]={show:show,hide:hide};
        return true;
    }
    function setVisibility (id, state, store, style) {
        var visData = getVisibilityData(id);
        var chosenStyle=visibilityStyles[style];
        var scAvail=(!jQuery.browser.opera) && (chosenStyle!=null) && (typeof(Effect) != "undefined") && (typeof(Effect[chosenStyle.show])!="undefined") && (typeof(Effect[chosenStyle.hide])!="undefined");
        var method;
        if (!state) {
            method = (scAvail) ? "s" : "p";// we can use either since we are hiding
        } else {
            method = ((scAvail) && (visData.method!=null)) ? visData.method : "p";// if scr is avail then use what we used last time otherwise use plain mode
        }
        visibilitySetting[id]=state;
        if (method=="s") {
            method="s";// script
            if (!state) {
                Effect[chosenStyle.hide](id);
            } else {
                Effect[chosenStyle.show](id);
            }
        } else {
            method="p";// plain
            var panelDiv = document.getElementById(id);
            if (panelDiv!=null) {
              if (!state) {
                  if (jQuery.browser.msie) {
                      panelDiv.style.display = "none";
                  } else {
                      panelDiv.style.visibility = "collapse";
                      panelDiv.style.display = "none";
                  }
              } else {
                  if (jQuery.browser.msie) {
                      panelDiv.style.display = "block";
                  } else {
                      panelDiv.style.visibility = "visible";
                      panelDiv.style.display = (typeof(panelDiv.cellIndex)!="undefined") ? "table-cell" : null;
                  }
              }
            }
        }
        if (store) setVisibilityCookie(id,state,method);
        if (typeof(BuilderEvents)!="undefined") BuilderEvents.fireEvent("set-"+id+"visibility",{id:id, state:state})
        return state;
    }
    function toggleVisibility (id,store,style) {
        visibilitySetting[id] = visibilitySetting[id]==null || visibilitySetting[id];
        return setVisibility(id,!visibilitySetting[id],store,style);
    }
    function restoreVisibility (id,def,store,style,force) {
        var visData = getVisibilityData(id);
        var visible = (force) ? def :(visData!=null && visData.visible!=null) ? visData.visible : def;
        return setVisibility(id,visible,store,style);
    }
    function addClass(target,className) {
        var orig=target.className;
        if (orig!=null) {
            var i=orig.indexOf(className);
            if (i<0) {
                target.className=target.className+" "+className;
            }
        } else {
            target.className=className;
        }
    }
    function removeClass(target,className) {
        var orig=target.className;
        if (orig!=null) {
            var i=orig.indexOf(className);
            if (i>-1) {
                var newClass=orig.substr(0,i);
                if (i+className.length<orig.length) {
                    newClass+=orig.substr(i+className.length);
                }
                target.className=newClass;
            }
        }
    }
    function setState (id, state, postfix) {
        var target=document.getElementById(id+postfix);
        if (target!=null) {
            if (state) {
                removeClass(target,"collapsed"+postfix);
                addClass(target,"expanded"+postfix);
            } else {
                removeClass(target,"expanded"+postfix);
                addClass(target,"collapsed"+postfix);
            }
        }
    }
    function toggleSidebar (id) {
        var state=toggleVisibility("atb-"+id,true,"fade");
        setState("atb-"+id,state,"");
        setState("atb-"+id,state,"-slider");
        if (typeof(BuilderEvents)!="undefined") BuilderEvents.fireEvent("toggle-sidebar",{id:id, state:state})
    }
    function restoreSidebar (id,collapse,force) {
        var state=restoreVisibility("atb-"+id,!collapse,true,"fade",force);
        setState("atb-"+id,state,"");
        setState("atb-"+id,state,"-slider");
    }
    return {addVisibilityStyle:addVisibilityStyle,
            setVisibility:setVisibility,
            setVisibilityCookie:setVisibilityCookie,
            toggleVisibility:toggleVisibility,
            restoreVisibility:restoreVisibility,
            toggleSidebar:toggleSidebar,
            addClass:addClass,
            removeClass:removeClass,
            restoreSidebar:restoreSidebar};
})();
